// This file was generated by SquareLine Studio
// SquareLine Studio version: SquareLine Studio 1.4.0
// LVGL version: 8.3.6
// Project name: Cardv

/*
* 此文件由 SquareLine Studio 工具生成
* 文件功能：各种控件的回调处理函数、用于对接用户功能逻辑
* 命名规范：
* ========================CusXXXX
* Cus前缀的函数均为用户自定义函数，用于实现部分功能逻辑，須自行调用
* ========================SysXXXX
* Sys前缀的函数为各控件的回调函数，在 SquareLine Studio 工具中定义函数名后自动生成，控件有触摸事件时会自动调用执行
* 回调函数初始均为空函数，用于对接用户的功能逻辑代码
* ========================常用接口
*
*/
#include "ui.h"
#include "lvgl/lvgl.h"

#include "mainLogic.h"
#include "statusbar.h"
#include "playbackLogic.h"
#include "VideoMenuLogic.h"
#include "TimerEventContext.h"
#include "OSDStringCommon.h"

/*************************************************
 *                  Cus Function
 *************************************************/
bool CusGetWidgetFlags(lv_obj_t * p)
{
	return (p->flags & LV_OBJ_FLAG_HIDDEN) ? false : true;
}

void CusSetWidgetFlags(lv_obj_t * target, int32_t flag, int value)
{
	if(value == _UI_MODIFY_FLAG_ADD && CusGetWidgetFlags(target)){
		_ui_flag_modify(target, flag, value);
	} else if (value == _UI_MODIFY_FLAG_REMOVE && !CusGetWidgetFlags(target)) {
		_ui_flag_modify(target, flag, value);
	}
}

void CusSetWidgetBgImgSrc(struct _lv_obj_t * obj, const void * value, lv_style_selector_t selector)
{
	lv_style_value_t v = lv_obj_get_style_prop(obj, LV_PART_MAIN, LV_STYLE_BG_IMG_SRC);

	if((const void *)v.ptr != value){
		lv_obj_set_style_bg_img_src(obj, value, selector);
	}
}


/*************************************************
 *                  Main Screen
 *************************************************/
/* User Customer Function */
bool CusIsMainScreen(void)
{
	lv_obj_t * p = lv_scr_act();
	if(p == ui_MainScreen){
		return true;
	} else {
		return false;
	}
}

void CusChangeMainScreen(void)
{
	_ui_screen_change(&ui_MainScreen, LV_SCR_LOAD_ANIM_NONE, 0, 0, &ui_MainScreen_screen_init);
}

/* MainScreen Load Call-back Function*/
void SysMainScreenInit(lv_event_t * e)
{
	// Your code here
	onUI_init_main();
}

void SysMainScreenShow(lv_event_t * e)
{
	// Your code here
	onUI_show_main();
}

void SysMainScreenHide(lv_event_t * e)
{
	// Your code here
	onUI_hide_main();
}

/* MainScreen Button Call-back Function*/
void SysCaptureButton(lv_event_t * e)
{
	// Your code here
	onButtonClick_CameraButton();
}

void SysRecordButtonEvent(lv_event_t * e)
{
	// Your code here
	onButtonClick_VideoButton();
}

void SysPlaybackButtonEvent(lv_event_t * e)
{
	// Your code here
	lv_event_code_t event_code = lv_event_get_code(e);
	lv_obj_t * target = lv_event_get_target(e);
	if(event_code == LV_EVENT_RELEASED) {
		onButtonClick_PlaybackButton();
	}
}

void SysSettingsButtonEvent(lv_event_t * e)
{
	// Your code here
	lv_event_code_t event_code = lv_event_get_code(e);
	lv_obj_t * target = lv_event_get_target(e);
	if(event_code == LV_EVENT_RELEASED) {
		onButtonClick_SettingsButton();
	}
}


/*************************************************
 *               VideoMenu Screen
 *************************************************/
/* VideoMenuScreen User Customer Function */
bool CusIsVideoMenuScreen(void)
{
	lv_obj_t * p = lv_scr_act();
	if(p == ui_MenuScreen){
		return true;
	} else {
		return false;
	}
}

void CusChangeVideoMenuScreen(void)
{
	_ui_screen_change(&ui_MenuScreen, LV_SCR_LOAD_ANIM_NONE, 0, 0, &ui_MenuScreen_screen_init);
}

/* VideoMenuScreen Load Call-back Function */
void SysMenuScreenInit(lv_event_t * e)
{
	// Your code here
	onUI_init_menu();
}

void SysMenuScreenShow(lv_event_t * e)
{
	// Your code here
	onUI_show_menu();
}

void SysMenuScreenHide(lv_event_t * e)
{
	// Your code here
	onUI_hide_menu();
}

void SysConfirmNoButtonEvent(lv_event_t * e)
{
	// Your code here
	onButtonClick_SubMenuConfirm_no();
}

void SysConfirmYesButtonEvent(lv_event_t * e)
{
	// Your code here
	onButtonClick_SubMenuConfirm_yes();
}

/* MainScreen Format-SD Call-back Function*/
void SysFormatConfirmNOButtonEvent(lv_event_t * e)
{
	// Your code here
	onButtonClick_FormatConfirmNO();
}

void SysFormatConfirmYesButtonEvent(lv_event_t * e)
{
	// Your code here
	onButtonClick_FormatConfirmYes();
}


/*************************************************
 *               PlayBack Screen
 *************************************************/
/* User Customer Function */
bool CusIsPlayBackScreen(void)
{
	lv_obj_t * p = lv_scr_act();
	if(p){
		return true;
	} else {
		return false;
	}
}


void SysPlaybackScreenInit(lv_event_t * e)
{
	// Your code here
	onUI_init_playback();
}

void SysPlaybackScreenShow(lv_event_t * e)
{
	// Your code here
	onUI_show_playback();
}

void SysPlaybackScreenHide(lv_event_t * e)
{
	// Your code here
	onUI_hide_playback();
}

void SysBackButtonEvent(lv_event_t * e)
{
	// Your code here
	onButtonClick_PlaybackQuitButton();
}

void SysDeleteButtonEvent(lv_event_t * e)
{
	// Your code here
	onButtonClick_PlaybackSubDelectButton();
}



/*************************************************
 *               Statusbar Screen
 *************************************************/
/* User Customer Function */
#define TIMER_MS	500
#define TIMER_NAME	"cus_statusbar_timer"

lv_timer_t * ui_Timer;
lv_obj_t * ui_SysStatusBar;
lv_obj_t * ui_SysWarnLabel;
static void *m_cardv_timer = NULL;
static bool statusbar_show_flag = false;

extern pthread_mutex_t mutex;

static void cus_statusbar_timer_handler(int signo)
{
	static int count = 0;
	pthread_mutex_lock(&mutex); //互斥锁上锁
	//statusbar hide
	if(++count >= 2){
		count = 0;
		onUI_Timer_Statusbar();
	}
	//statusbar show
	if(statusbar_show_flag) {
		statusbar_show_flag = false;
		_ui_flag_modify(ui_SysStatusBar, LV_OBJ_FLAG_HIDDEN, _UI_MODIFY_FLAG_REMOVE);
	}
	pthread_mutex_unlock(&mutex);//互斥锁解锁
}
static void *cus_statusbar_timer_create(const char *name, void (*func)(void *), void *user_data)
{
	timer_t *timer = NULL;

	struct sigevent ent = { 0 };

	/* check parameter */
	if (func == NULL)
	{
		printf("%d timer invaild!\n", __LINE__);
		return NULL;
	}

	timer = (timer_t *)malloc(sizeof(time_t));

	/* Init */
	memset(&ent, 0x00, sizeof(struct sigevent));

	/* create a timer */
	ent.sigev_notify          = SIGEV_THREAD;
	ent.sigev_notify_function = (void (*)(union sigval))func;
	ent.sigev_value.sival_ptr = user_data;

	printf("create %s\n", name);

	if (timer_create(CLOCK_MONOTONIC, &ent, timer) != 0)
	{
		printf("create faild!\n");
		free(timer);
		return NULL;
	}

	printf("create %p timer\n", timer);
	return (void *)timer;
}

static int Cus_statusbar_timer_start(void *timer, int ms)
{
	struct itimerspec ts;

	/* check parameter */
	if (timer == NULL)
	{
		printf("timer invaild!\n");
		return -1;
	}

	printf("strart %p %d ms\n", timer, ms);

	/* it_interval=0: timer run only once */
	ts.it_interval.tv_sec  = ms / 1000;
	ts.it_interval.tv_nsec = (ms % 1000) * 1000000;

	/* it_value=0: stop timer */
	ts.it_value.tv_sec  = ms / 1000;
	ts.it_value.tv_nsec = (ms % 1000) * 1000000;

	return timer_settime(*(timer_t *)timer, 0, &ts, NULL);
}

static int Cus_statusbar_timer_stop(void *timer)
{
	struct itimerspec ts;

	/* check parameter */
	if (timer == NULL)
	{
		printf("timer invaild!\n");
		return -1;
	}

	printf("stop %p\n", timer);
	/* it_interval=0: timer run only once */
	ts.it_interval.tv_sec  = 0;
	ts.it_interval.tv_nsec = 0;

	/* it_value=0: stop timer */
	ts.it_value.tv_sec  = 0;
	ts.it_value.tv_nsec = 0;

	return timer_settime(*(timer_t *)timer, 0, &ts, NULL);
}

static int Cus_statusbar_timer_delete(void *timer)
{
	int ret = 0;

	/* check parameter */
	if (timer == NULL)
	{
		printf("timer invaild!\n");
		return -1;
	}

	printf("delete %p\n", timer);
	ret = timer_delete(*(timer_t *)timer);

	free(timer);

	return ret;
}

static void Cus_statusbar_timer_init(void)
{
	if (!m_cardv_timer)
	{
		m_cardv_timer = cus_statusbar_timer_create(TIMER_NAME, (void (*)(void *))cus_statusbar_timer_handler, NULL);
		Cus_statusbar_timer_start(m_cardv_timer, TIMER_MS);
	}
}

static void Cus_statusbar_timer_uninit(void)
{
	if (m_cardv_timer)
	{
		Cus_statusbar_timer_stop(m_cardv_timer);
		Cus_statusbar_timer_delete(m_cardv_timer);
	}
}

void CusStatusbarInit(void)
{
	lv_obj_t * ui_TopScreen = lv_layer_top();
	lv_obj_clear_flag(ui_TopScreen, LV_OBJ_FLAG_SCROLLABLE);      /// Flags
	lv_obj_set_style_bg_color(ui_TopScreen, lv_color_hex(0xFFFFFF), LV_PART_MAIN | LV_STATE_DEFAULT);
	lv_obj_set_style_bg_opa(ui_TopScreen, 0, LV_PART_MAIN | LV_STATE_DEFAULT);

	ui_SysStatusBar = lv_obj_create(ui_TopScreen);
	lv_obj_set_width(ui_SysStatusBar, 495);
	lv_obj_set_height(ui_SysStatusBar, 196);
	lv_obj_set_x(ui_SysStatusBar, 0);
	lv_obj_set_y(ui_SysStatusBar, -10);
	lv_obj_set_align(ui_SysStatusBar, LV_ALIGN_CENTER);
	lv_obj_clear_flag(ui_SysStatusBar, LV_OBJ_FLAG_SCROLLABLE);      /// Flags
	lv_obj_set_style_radius(ui_SysStatusBar, 15, LV_PART_MAIN | LV_STATE_DEFAULT);
	lv_obj_set_style_bg_color(ui_SysStatusBar, lv_color_hex(0x0BB0F5), LV_PART_MAIN | LV_STATE_DEFAULT);
	lv_obj_set_style_bg_opa(ui_SysStatusBar, 255, LV_PART_MAIN | LV_STATE_DEFAULT);
	lv_obj_set_style_border_color(ui_SysStatusBar, lv_color_hex(0x000000), LV_PART_MAIN | LV_STATE_DEFAULT);
	lv_obj_set_style_border_opa(ui_SysStatusBar, 0, LV_PART_MAIN | LV_STATE_DEFAULT);
	lv_obj_set_style_outline_color(ui_SysStatusBar, lv_color_hex(0xF31515), LV_PART_MAIN | LV_STATE_DEFAULT);
	lv_obj_set_style_outline_opa(ui_SysStatusBar, 0, LV_PART_MAIN | LV_STATE_DEFAULT);
	lv_obj_set_style_outline_width(ui_SysStatusBar, 0, LV_PART_MAIN | LV_STATE_DEFAULT);
	lv_obj_set_style_outline_pad(ui_SysStatusBar, 0, LV_PART_MAIN | LV_STATE_DEFAULT);
	_ui_flag_modify(ui_SysStatusBar, LV_OBJ_FLAG_HIDDEN, _UI_MODIFY_FLAG_ADD);

	ui_SysWarnLabel = lv_label_create(ui_SysStatusBar);
	lv_obj_set_height(ui_SysWarnLabel, 24);
	lv_obj_set_width(ui_SysWarnLabel, lv_pct(100));
	lv_obj_set_align(ui_SysWarnLabel, LV_ALIGN_CENTER);
	lv_label_set_text(ui_SysWarnLabel, "No SD Card!");
	lv_obj_set_style_text_color(ui_SysWarnLabel, lv_color_hex(0xFFFFFF), LV_PART_MAIN | LV_STATE_DEFAULT);
	lv_obj_set_style_text_opa(ui_SysWarnLabel, 255, LV_PART_MAIN | LV_STATE_DEFAULT);
	lv_obj_set_style_text_align(ui_SysWarnLabel, LV_TEXT_ALIGN_CENTER, LV_PART_MAIN | LV_STATE_DEFAULT);
	lv_obj_set_style_text_font(ui_SysWarnLabel, font_montserrat_20, LV_PART_MAIN | LV_STATE_DEFAULT);

	Cus_statusbar_timer_init();
}

bool CusGetStatusbarFlags(void)
{
	return (ui_SysStatusBar->flags & LV_OBJ_FLAG_HIDDEN) ? false : true;
}

bool CusSetStatusbarFlags(char state)
{
	if( state == _UI_MODIFY_FLAG_REMOVE) {
		statusbar_show_flag = true;
	} else {
		_ui_flag_modify(ui_SysStatusBar, LV_OBJ_FLAG_HIDDEN, _UI_MODIFY_FLAG_ADD);
	}
}

void CusStatusbarWarnText(const char * text)
{
	lv_obj_set_style_text_font(ui_SysWarnLabel, font_montserrat_20, LV_PART_MAIN | LV_STATE_DEFAULT);
	lv_label_set_text(ui_SysWarnLabel, text);
}

/*************************************************
 *               PowerOff Screen
 *************************************************/
/* User Customer Function */
bool CusIsPowerOffScreen(void)
{
	lv_obj_t * p = lv_scr_act();
	if(p){
		return true;
	} else {
		return false;
	}
}
